Option Compare Binary
Option Explicit On 
Option Strict On

Imports System
Imports System.Reflection
Imports RemoteLoader

Public Class Class1
    Inherits MarshalByRefObject
    Implements IRemoteInterface

    Public Function Invoke( _
        ByVal Method As String, _
        ByVal Params() As Object _
    ) As Object Implements IRemoteInterface.Invoke
        Return _
            Me.GetType().InvokeMember( _
                Method, _
                BindingFlags.InvokeMethod, _
                Nothing, _
                Me, _
                Params _
            )
    End Function

    Shared Sub New()
        Console.WriteLine("'Class1':  Allocating shared unmanaged resources.")
    End Sub

    Private Shared Finalizer As New SharedFinalizer

    Private Class SharedFinalizer
        Protected Overrides Sub Finalize()
            MyBase.Finalize()
            Console.WriteLine("'Class1':  Releasing shared unmanaged resources.")
        End Sub
    End Class

    Public Shared Sub DoSomething()
        Console.WriteLine("'Class1':  Access to shared member.")
    End Sub
End Class